routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\DefaultController;
use App\Http\Controllers\Admin\AdminContentController;
use App\Http\Controllers\Admin\AdminPostController;
use App\Http\Controllers\Admin\AdminCallController;
use App\Http\Controllers\Admin\AdminContentEditableController;

Route::group(['prefix' => 'admin', 'middleware' => ['auth', 'verified', 'can:manager', 'adminPanel']], function () {
    // шлюзы 'admin' и 'manager' описан в app/Providers/AuthServiceProvider.php
    // у админа обязательно есть role 'manager'
    Route::controller(AdminContentController::class)->middleware('can:admin')->group(function () {
        Route::get('/content/trash', 'trash')->name('content.trash');
        Route::put('/content/{id}/restore', 'restore')->whereNumber(['id'])->name('content.restore');
        Route::delete('/content/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('content.remove');
        Route::resource('/content', AdminContentController::class)->parameters(['id' => 'id']);
    });
    // режим contenteditable
    Route::controller(AdminContentEditableController::class)->middleware('can:admin')->group(function () {
        Route::get('/content/{id}/contenteditable', 'index')->whereNumber(['id'])->name('contenteditable');
        Route::post('/content/contenteditable', 'store')->name('contenteditable.store');
    });
    // большая группа роутов
    Route::group(['middleware' => 'can:manager'], function () {
        Route::controller(DefaultController::class)->group(function () {
            Route::get('/', 'index')->name('admin.index');
            Route::post('/cache', 'cache')->name('admin.cache');
            Route::post('/last', 'last')->name('admin.last');
        });

        Route::controller(AdminPostController::class)->group(function () {
            Route::get('/post/trash', 'trash')->name('post.trash');
            Route::put('/post/{id}/restore', 'restore')->whereNumber(['id'])->name('post.restore');
            Route::delete('/post/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('post.remove');
            Route::delete('/post/clearTrash', 'clearTrash')->name('post.clear');
            Route::delete('/post/destroyAll', 'destroyAll')->name('post.destroyAll');
            Route::delete('/post/deleteAll', 'deleteAll')->name('post.deleteAll');
        });

        Route::controller(AdminCallController::class)->group(function () {
            Route::get('/call/trash', 'trash')->name('call.trash');
            Route::put('/call/{id}/restore', 'restore')->whereNumber(['id'])->name('call.restore');
            Route::delete('/call/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('call.remove');
            Route::delete('/call/clearTrash', 'clearTrash')->name('call.clear');
            Route::delete('/call/destroyAll', 'destroyAll')->name('call.destroyAll');
            Route::delete('/call/deleteAll', 'deleteAll')->name('call.deleteAll');
        });

        Route::resource('/call', AdminCallController::class)->parameters('id')->whereNumber(['id']);
        Route::resource('/post', AdminPostController::class)->parameters(['id' => 'id'])->whereNumber(['id']);
    });

    Route::get('/phpinfo', function () {
        return phpinfo();
    })->name('admin.phpinfo');
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ContentController;
use App\Http\Controllers\OAuth\OauthController;
use App\Http\Controllers\Admin\CKEditorController;
use App\Http\Controllers\PostsController;
use App\Http\Controllers\CallsController;
use App\Http\Controllers\DesignerController;
use App\Http\Controllers\ChatController;


Route::get('/', [ ContentController::class, 'index' ])->name('content.index');

// Всякие эксперименты
require __DIR__ . '/test.php';

// страницы оптимизации сайтов
require __DIR__ . '/seo.php';

// конструктор чехлов
Route::get('/designer', [ DesignerController::class, 'index' ])->name('designer.index');
Route::post('/constructor', [ DesignerController::class, 'store' ])->name('designer.store');

// ограничения описаны в app/Providers/AppServiceProvider.php
Route::middleware(['throttle:formsLimit'])->group(function () {
    Route::post('/mail', [ PostsController::class, 'store' ])->name('mail.store');
    Route::post('/zvonok', [ CallsController::class, 'store' ])->name('zvonok.store');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

// Oauth2 аутентификация
Route::get('auth/{service}', [OauthController::class, 'redirectToService'])->whereIn('service', ['google', 'github', 'mailru', 'odnoklassniki', 'vkontakte', 'yandex']);
Route::get('auth/{service}/callback', [OauthController::class, 'handleCallback'])->whereIn('service', ['google', 'github', 'mailru', 'odnoklassniki', 'vkontakte', 'yandex']);

require __DIR__.'/ws.php';

require __DIR__.'/admin.php';

require __DIR__.'/auth.php';

// чат где вебсокет сервер на Laravel
Route::get('/chat', [ ContentController::class, 'chat' ])->name('content.chat');
// чат где вебсокет сервер на поднимается отдельно на Node js
Route::get('/nodechat', [ ContentController::class, 'nodechat' ])->name('content.nodechat');
// чат на setTimeout VUE3 MYSQL
Route::get('/vchat', [ ChatController::class, 'index' ])->name('content.chat');
Route::get('/vchat/all', [ ChatController::class, 'all' ]);
Route::get('/vchat/update', [ ChatController::class, 'update' ]);
Route::post('/vchat/store', [ ChatController::class, 'store' ]);
Route::get('/csrf', [ ChatController::class, 'csrf' ]);

// все остальные страницы кроме главной
//Route::get('/{page}', [ ContentController::class, 'page' ])->name('content.page')->whereIn('page', ['sozdanie', 'prodvijenie', 'portfolio', 'parsing', 'bla']);
Route::get('/{page}', [ ContentController::class, 'page' ])->name('content.page');

Route::post('ckeditor/image_upload', [ CKEditorController::class, 'upload' ])->name('upload');

app/Models/Call.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use App\Enums\Call\Status as CallStatus;

class Call extends Model
{
    use HasFactory;
    use SoftDeletes;
//    protected $guarded = [];
    protected $fillable = [
        'name',
        'tel',
    ];

    // касты
    protected $casts = [
       'status' => CallStatus::class,
    ];
}

app/Http/Controllers/CallsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Call;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Mail;
use App\Mail\Feedback;
use App\Http\Requests\CallFormRequest;
use MoveMoveIo\DaData\Enums\Gender;
use MoveMoveIo\DaData\Enums\Parts;
use MoveMoveIo\DaData\Facades\DaDataName;
use App\Jobs\SenderCall;

class CallsController extends AppFormsController
{
    public function index()
    {
        return 'Only POST method';
    }

    public function store(CallFormRequest $request)
    {
        $data = $request->validated();

        SenderCall::dispatch($data);
        if (Call::create($data)) {
            return response()->json([
                'success' => true,
            ]);
        } else {
            return response()->json([
                'success' => false
            ]);
        }
    }

    public function info(Request $request)
    {
        /*return response()->json([
            'success' => true,
            'count' => 4,
            'names' => ['вася', 'василий', 'василиса', 'васискис'],
        ]);*/
        $dadata = DaDataName::prompt($request->name, $count=5, Gender::UNKNOWN, [Parts::NAME]);
        $res = [];
        foreach ($dadata['suggestions'] as $v){
            array_push($res, $v['value']);
        }
        return response()->json([
            'success' => true,
            'count' => $count,
            'names' => $res
        ]);

    }

}

resources/views/admin/call/index.blade.php
@php
    use Jenssegers\Date\Date;
    use App\Enums\Call\Status as CallStatus;

    $h1 = $new ? 'Заказы обратных звонков - новые' : 'Заказы обратных звонков - все';

@endphp
<x-layouts.admin title="Заказы обратных звонков | страница {{ $calls->currentPage() }}">
    {{ Breadcrumbs::render('calls') }}
    <div class="d-flex"><h1>{{ $h1 }}</h1>
        @if($trashed)
            <div class="top-links">
                <a href="{{ route('call.trash') }}" class="btn btn-warning">Корзина</a>
            </div>
        @endif
    </div>
    @if($count)
        <div class="d-flex">
            @if($new)
                <a href="{{ route('call.index') }}" class="btn btn-success top-links">показать все</a>
            @else
                <a href="{{ route('call.index', ['sort' => 'new']) }}" class="btn btn-success top-links">только
                    новые</a>
            @endif
            <form class="top-links"
                  action="{{ route('call.destroyAll', [ 'sort' => $new ? 'new' : 'all', 'page' => $calls->currentPage() ]) }}"
                  method="post">
                @csrf
                @method('DELETE')
                <button class="btn btn-warning">
                    Все в корзину
                </button>
            </form>
            <form class="top-links del-form" action="{{ route('call.deleteAll') }}" method="post">
                @csrf
                @method('DELETE')
                <button class="btn btn-danger">
                    Все удалить безвозвратно
                </button>
            </form>
        </div>
        <div class="font-italic">{{ $count }} записей из {{ $total }}</div>
        <table class="table-bordered table-hover table-admin">
            <tr>
                <th>id</th>
                <th>Имя</th>
                <th>Телефон</th>
                <th>Дата</th>
                <th>Статус</th>
                <th>Действия</th>
            </tr>
            @foreach($calls as $call)
                <tr class="{{ $call->status === CallStatus::READ_STATUS ? '' : 'table-success' }}">
                    <td>{{ $call->id }}</td>
                    <td>{{ $call->name }}</td>
                    <td>{{ $call->tel }}</td>
                    @php
                        $date = Date::parse($call->created_at);
                    if($date->isYesterday()){
                        $date = 'вчера в ' . $date->format('H:i');
                    }elseif ($date->isToday()){
                        $date = 'сегодня в ' . $date->format('H:i');
                    }else{
                        $date = $date->format('j F Y H:i');
                    }
                    @endphp
                    <td>{{ $date }}</td>
                    <td>{{ $call->status->text() }}</td>
                    <td>
                        <div class="d-flex">
                            <div class="top-links"><a href="{{ route('call.show', [ $call->id ]) }}"><span
                                        class="fa fa-eye"></span></a></div>
                            <div class="top-links">
                                <form action="{{ route('call.destroy', [ $call->id ]) }}"
                                      method="post">
                                    @csrf
                                    @method('DELETE')
                                    <button>
                                        <span class="fa fa-trash text-danger"></span>
                                    </button>
                                </form>
                            </div>
                        </div>
                    </td>
                </tr>
            @endforeach
        </table>
    @else
        <h4>Нет данных</h4>
    @endif
    <br>
    {{ $calls->links('vendor.pagination.bootstrap-4') }}
</x-layouts.admin>

resources/views/admin/call/show.blade.php
@php
    use Jenssegers\Date\Date;
@endphp
<x-layouts.admin title="">
    {{ Breadcrumbs::render('call', $call) }}
    <div><b>Имя: </b>
        <span>{{ $call->name }}</span>
    </div>
    @if($call->tel)
        <div>
            <b>Тел.: </b>
            <span>{{ $call->tel }}</span>
        </div>
    @endif
    <div>
        <b>Дата: </b>
        @php
            $date = Date::parse($call->created_at);
        if($date->isYesterday()){
            $date = 'вчера в ' . $date->format('H:i');
        }elseif ($date->isToday()){
            $date = 'сегодня в ' . $date->format('H:i');
        }else{
            $date = $date->format('j F Y H:i');
        }
        @endphp
        <span>{{ $date }}</span>
    </div>
    <form style="display: inline-block" action="{{ route('call.destroy', [ $call->id ]) }}" method="post">
        @csrf
        @method('DELETE')
        <button class="btn btn-warning">В корзину</button>
    </form>
    <form class="del-form" style="display: inline-block" action="{{ route('call.remove', [ $call->id ]) }}" method="post">
        @csrf
        @method('DELETE')
        <button class="btn btn-danger">
            Удалить безвозвратно
        </button>
    </form>
</x-layouts.admin>

resources/views/admin/call/trash.blade.php
@php
    use Jenssegers\Date\Date;
@endphp
<x-layouts.admin title="Админка">
    {{ Breadcrumbs::render('calls_trashed') }}
    <h1>Корзина</h1>
    <div>
        <form action="{{ route('call.clear') }}" method="post" >
            @csrf
            @method('DELETE')
            <button class="btn btn-danger">
                Очистить
            </button>
        </form>
    </div>
    <table class="table-bordered table-hover table-admin">
        <tr>
            <th>id</th>
            <th>Имя</th>
            <th>Телефон</th>
            <th>Дата удаления</th>
            <th>Действия</th>
        </tr>
        @foreach($calls as $call)
            <tr>
                <td>{{$call->id }}</td>
                <td>{{ $call->name }}</td>
                <td>{{ $call->tel ?? 'не указан' }}</td>
                @php
                    $date = Date::parse($call->deleted_at);
                if($date->isYesterday()){
                    $date = 'вчера в ' . $date->format('H:i');
                }elseif ($date->isToday()){
                    $date = 'сегодня в ' . $date->format('H:i');
                }else{
                    $date = $date->format('j F Y H:i');
                }
                @endphp
                <td>{{ $date }}</td>
                <td>
                    <div class="d-flex">
                        <div>
                            <form class="top-links" action="{{ route('call.restore', [ $call->id ]) }}" method="post">
                                @csrf
                                @method('PUT')
                                <button class="btn btn-info">
                                    восстановить
                                </button>
                            </form>
                        </div>
                        <div>
                            <form class="top-links del-form" action="{{ route('call.remove', [ $call->id ]) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-danger">
                                    удалить безвозвратно
                                </button>
                            </form>
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
            </tr>
        @endforeach
    </table>
</x-layouts.admin>